package firework.boxy;

import firework.boxy.Normal.NormalBox.Reference;
import firework.itemy.Box;
import firework.itemy.Box.LaunchButton;
import firework.itemy.Box.Launcher;
import firework.itemy.Item;
import firework.itemy.Obal;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.ArrayList;


public class Normal implements BoxInterface {

    @Override
    public void itemReleased(Item i, Box b, int x, int y) {
        NormalBox nb=new NormalBox(b);
        if (i instanceof Obal){
          int position=nb.getLauncherIndex(x, y);
            System.out.println("Position "+position);
            if (position>=0){
                nb.launchers[position].obal=(Obal)i;                
            }
      }
        nb.validate();
    }

    
    
    @Override
    public void mouseDragged(int basex, int basey, int actualx, int actualy, Box b) {
        NormalBox nb=new NormalBox(b);
        int position=nb.getLauncherIndex(basex, basey);
            if (position>=0){
                b.linex1=NormalBox.LauncherX[position]+NormalBox.singleLauncherWidth/2;
                b.liney1=NormalBox.LauncherY+NormalBox.LauncherHeight/2;
                b.linex2=actualx;
                b.liney2=actualy;
            }
    }
    @Override
    public void mouseReleased(int basex,int basey,int actualX,int actualY,Box b){
        NormalBox nb=new NormalBox(b);       
        int launcherposition=nb.getLauncherIndex(basex, basey);
        int btnposition=nb.getBtnIndex(actualX,actualY);
            if (btnposition>=0&&launcherposition>=0){
                Launcher l=nb.launchers[launcherposition];
                LaunchButton lb= nb.buttons[btnposition];
                if (!lb.launchers.contains(l)){
                    lb.launchers.add(l);
                    System.out.println("ADDED "+lb.launchers.size());
                }
            }
            b.linex1=-1;
            b.liney1=-1;
            b.liney2=-1;
            b.linex2=-1;
            nb.validate();
    }

    @Override
    public BufferedImage vykresliMa(Box b) {
      NormalBox nb=new NormalBox(b);
        BufferedImage image=new BufferedImage(b.tb.work.getWidth(),b.tb.work.getHeight(),BufferedImage.TYPE_4BYTE_ABGR);
      Graphics g=image.getGraphics();
      g.drawImage(b.tb.work,0,0,null);
      int index=0;
        for (Launcher l:nb.launchers){
           if (l.obal!=null){
               g.drawImage(l.obal.ikona, NormalBox.LauncherX[index], 122,NormalBox.singleLauncherWidth,40, null);
           }
           index++;
        }
        g.setColor(Color.GREEN);
        if (b.linex1>0&&b.liney1>0&&b.linex2>0&&b.liney2>0)//Nepotrebne kedze ked je 1 suradnica mensia ako 0, vsetky by MALI byt vacsie, ale kontrola
             g.drawLine(b.linex1, b.liney1,b.linex2, b.liney2);
        for (LaunchButton lb:nb.buttons){
            for (Launcher l:lb.launchers){
                int x1=NormalBox.LauncherX[l.index]+NormalBox.singleLauncherWidth/2;
                int y1=NormalBox.LauncherY+NormalBox.LauncherHeight/2;
                int x2=lb.x+LaunchButton.width/2;
                int y2=lb.y+LaunchButton.height/2;
                g.drawLine(x1, y1, x2, y2);
            }
        }
        return image;
    }
    
    protected static class NormalBox{
        
        final static int LauncherY=27;
        final static int LauncherHeight=135;
        final static int[] LauncherX={90,139,198,252};
        final static int singleLauncherWidth=50;
        final static int fullLauncherWidth=216;
                
        Launcher[] launchers;
        LaunchButton[] buttons;
        ArrayList<Reference> references=new ArrayList<>();
        Box b;
        
        public static class Reference{
            public int launcherIndex;
            public int btnindex;
            
            public Reference(int launcherIndex,int btnindex){
                this.btnindex=btnindex;
                this.launcherIndex=launcherIndex;
            }
            
           
        }
                
        public NormalBox(Box b){           
           this.b=b;
            buttons=b.lb;
           int index=0;
           launchers=b.launchery;          
           
           for (LaunchButton lb:b.lb){
               for (Launcher l:lb.launchers){
                   references.add(new Reference(l.index,lb.index));
               }
           }
        }
        
         public int getLauncherIndex(int x,int y){ 
             if (jeVStvorci(x, y, NormalBox.LauncherX[0], NormalBox.LauncherY, NormalBox.fullLauncherWidth, NormalBox.LauncherHeight)){                       
                        int iter=0;
                        for (int launcherX:NormalBox.LauncherX){
                            if (x<launcherX){
                                return iter-1;
                            }
                            iter++;
                        }
                        return NormalBox.LauncherX.length-1;
            }
                return -1;
         }
                
         public int getBtnIndex(int x,int y){
             int actual=0;
             for (LaunchButton lb:buttons){
                 if (jeVStvorci(x, y, lb.x, lb.y, LaunchButton.width, LaunchButton.height)){
                     return actual;
                 }
                 actual++;
             }
             return -1;
         }
         
         public void validate(){            
             for (Reference r:this.references){
                 buttons[r.btnindex].launchers.add(b.launchery[r.launcherIndex]);
             }
             int index=0;
         }
    }
    
    
    
    
    
    private static boolean jeVStvorci(int x,int y,int stvorecX,int stvorecY,float stvorecWidth,float stvorecHeight){
        boolean horizontal=stvorecX<x&&x<stvorecX+stvorecWidth;
        boolean vertical=stvorecY<y&&y<stvorecY+stvorecHeight;
        return vertical&&horizontal;
    }
}
