package firework.itemy;

import firework.Refreshable;
import firework.typy.TypBox;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.ArrayList;


public class Box extends Item {

    public TypBox tb;
    public Launcher[] launchery={new Launcher(190,0),new Launcher(190,1),new Launcher(170,2),new Launcher(170,3)};
    public LaunchButton[] lb={new LaunchButton(65,227,0),new LaunchButton(140,227,1),
        new LaunchButton(218,224,2),new LaunchButton(298,223,3)
    };
    
    static int pocet=0;
    
    
    public ArrayList<Obal> odpalene=new ArrayList<>();
    
    public Box(TypBox tb,boolean isDefault) {
        super(tb.ikona,tb.work,"Box "+Integer.toString(pocet),isDefault);
        pocet++;
        this.tb=tb;
    }
    
    public static class Launcher{       
        public Obal obal;
        public int index;
        int angle=180;
        
        public Launcher(int angle,int index){
            this.angle=angle;
            this.index=index;
        }
        
        public Obal launch(int x,int y,int gravity,int bottom){
            if (obal!=null){
                obal.odpal(x, y, angle, gravity, bottom);
            }
            return obal;
        }
        @Override
        public Object clone(){
            Launcher l=new Launcher(angle,index);
            l.obal=(Obal)obal.clone();
            return l;
        }
    }
    
    public void update(){
        for (Obal o:odpalene){        
            o.update();
        }
    }
    
    final static int boxwidth=5,boxheight=5;
    
    public int x,y;
    
    public void vykresliSa(Graphics g){
        g.drawImage(ikona, x, y-boxheight,boxwidth,boxheight, null);
        for (Obal o:odpalene){
            o.vykresliSa(g);
        }
    }

    
    public static class LaunchButton{
        public int x,y;
        public ArrayList<Launcher> launchers=new ArrayList<>();
        public final static int width=53;
        public final static int height=50;
        public int index;
        
        public LaunchButton(int x,int y,int index){
            this.x=x;
            this.y=y;
            this.index=index;
        }

       @Override
       public Object clone(){
           LaunchButton lb=new LaunchButton(x,y,index);
           lb.launchers=(ArrayList)launchers.clone();
           ArrayList<Launcher> launchers=new ArrayList<>();
           for (Launcher l:this.launchers){
               launchers.add((Launcher)l.clone());
           }
           return lb;
       }
    }
    
    
    int pressX,pressY;
    boolean pressed;
    public int linex1,linex2,liney1,liney2;
    @Override
    public void mouseMoved(int x, int y) {
      if (pressed)
        tb.bi.mouseDragged(pressX, pressY, x, y, this);
    }

    @Override
    public void mousePressed(int x, int y) {
      pressed=true;
      pressX=x;
      pressY=y;
    }

    @Override
    public void mouseReleased(int x, int y) {
        tb.bi.mouseReleased(pressX, pressY, x, y, this);
        pressed=false;
    }

    @Override
    public void itemReleased(Item i, int x, int y) {
         tb.bi.itemReleased(i, this, x, y);
    }

    @Override
    public BufferedImage getWorkImage() {
       return tb.bi.vykresliMa(this);
    }

    @Override
    public Object clone() {
      Box b=new Box(this.tb,false);
      System.out.println("CLONING "+this.lb[0].launchers.size());
      if (this.lb!=null){
            b.lb=this.lb.clone();
      }
      if (this.launchery!=null){
               b.launchery=this.launchery.clone();
      }
      System.out.println("RESULT "+b.lb[0].launchers.size());
      return b;
    }
    
}
