package firework.itemy;
import firework.typy.Efekt;
import firework.typy.TypPrvok;
import firework.*;
import firework.itemy.Item;
import firework.typy.TypGulicka;
import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import javax.swing.*;

public class Gulicka extends Item {
    Color farba;
    ArrayList<Efekt> efekty=new ArrayList<>();
    TypGulicka typgulicka;
    String prvky="";
    final static Color defaultColor=Color.BLACK;//Todo change Alpha
    
    static int pocet=0;
    
    public Gulicka(TypGulicka typgulicka,boolean isDefault){
        super(typgulicka.obrazok,typgulicka.workshop,"Gulicka "+Integer.toString(pocet),isDefault);        
        this.typgulicka=typgulicka;
        pocet++;
    }

    
    private Gulicka(TypGulicka typgulicka){
        super(typgulicka.obrazok,typgulicka.workshop,"Gulicka "+Integer.toString(pocet));        
        this.typgulicka=typgulicka;
        pocet++;
    }


    /**
     * Prida prvok
     */
    private void addPrvok(Prvok gprvok){
        TypPrvok prvok=gprvok.prvok;
        if (prvok.farba!=null){
            if (this.farba!=null){
            this.farba=namixuj(farba,prvok.farba);
            }else{
                this.farba=prvok.farba;
            }
        }
        if (prvok.efekt!=null){
            if (!efekty.contains(prvok.efekt)){
               efekty.add(prvok.efekt);
            }
        }
    }
    
    /**
     * Namixuje 2 farby
     */
    private Color namixuj(Color a,Color b){
       return new Color((a.getRed()+b.getRed())/2
                ,(a.getGreen()+b.getGreen())/2
                ,(a.getBlue()+b.getBlue())/2);
    }
    
    @Override
    public Object clone(){
        Gulicka g=new Gulicka(this.typgulicka);
        g.farba=this.farba;
        g.efekty=this.efekty;
        g.prvky=this.prvky;
        return g;
    }

    @Override
    public void mouseMoved(int x, int y) {
       //ignore
     }

    @Override
    public void mousePressed(int x, int y) {
        //ignore
    }

    @Override
    public void mouseReleased(int x, int y) {
        //ignore
    }

    @Override
    public void itemReleased(Item i, int x, int y) {
        if (i instanceof Prvok){
            addPrvok((Prvok)i);
             Prvok p=(Prvok)i;
             prvky+=p.prvok.znacka+", ";
        }
    }

    @Override
    public BufferedImage getWorkImage() {
       //TODO Ak je text dlhsi rozlozit ho na kusky
        BufferedImage bi=new BufferedImage(workshop.getWidth(), workshop.getHeight(), BufferedImage.TYPE_4BYTE_ABGR);       
       Graphics g=bi.getGraphics();
       g.drawImage(this.workshop, 0, 0, null);
       FontMetrics fm=g.getFontMetrics();
       int x=(bi.getWidth()-fm.charsWidth(prvky.toCharArray(), 0, prvky.length()))/2;
       int y=(bi.getHeight()-fm.getHeight())/2;
       g.setColor(Color.RED);
       g.drawString(prvky, x, y);
       super.zmenIkona(bi);
       return bi;
    }
    
    public void vykresliSa(int x,int y,Graphics g){
        if (this.farba==null){
            this.farba=defaultColor;
        }       
        g.setColor(this.farba);
        g.fillRect(x, y, 2,2);
        for (Efekt e:efekty){
            e.ei.doSomething(x, y);
        }
    }

    
}
