package firework.itemy;

import firework.H;
import firework.MouseInterface;
import java.awt.image.BufferedImage;
import java.awt.event.MouseEvent;

public abstract class Item{
    public BufferedImage ikona;//normalny ikona
    public BufferedImage workshop;//obraz vo workshope
    public String nazov;
    public boolean isDefault;
    
    final static int defaultwidth=50;//vyska ikony
    final static int defaulthieght=50;
       
    public Item(BufferedImage obraz,BufferedImage workshop,String nazov,boolean isDefault){
        //TODO prepisat metodu equals aby sa v listoch nevyskytoval ten isty objekt viac-krat
        this.workshop=workshop;
        long time=System.currentTimeMillis();
        this.ikona=H.scaleImage(obraz, defaultwidth, defaulthieght);
        this.nazov=nazov;
        this.isDefault=isDefault;
    }
    /**
     * Kontruktor pre generovanie Klonov 
     * POZOR! Konstuktor nemeni velkost ikony (to je vlastne ten rozdiel :) ),preto ocakava ze ikona je uz zmensena
     * @param obraz
     * @param workshop
     * @param nazov 
     */
    protected Item(BufferedImage obraz,BufferedImage workshop,String nazov){
        //TODO prepisat metodu equals aby sa v listoch nevyskytoval ten isty objekt viac-krat
        this.workshop=workshop;
        this.ikona=obraz;
        this.nazov=nazov;
        this.isDefault=false;
    }
    /**
     * Ak bol na tento Item pusteny iny Item (vo WorkSpace)
     */
    public abstract void itemReleased(Item i,int x,int y);
    
    public abstract void mouseMoved(int x,int y);
    
    public abstract void mousePressed(int x,int y);
    
    public abstract void mouseReleased(int x,int y);
    
    public abstract BufferedImage getWorkImage();
        
    
    @Override
    public abstract Object clone();
    
    public void zmenIkona(BufferedImage novy){
        this.ikona=H.scaleImage(novy, defaultwidth, defaulthieght);
    }
        
}
