package firework.itemy;

import firework.obaly.ObalInterface;
import firework.typy.TypObal;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.ArrayList;


public class Obal extends Item {
    
    private ObalInterface o;
    private TypObal to;
    public float PusnyPrach1=0.20F;//Prva Faza, let do vzduchu
    public float PusnyPrach2=0.20F;//Druha Faza, vybuchnutie guliciek
    public float timer=0.20F;
    public ArrayList<GulickaNaVybuchnutie> gulicky=new ArrayList<>();
    
    static int pocet=0;   
    public Obal(TypObal to,boolean isDefault){
       super(to.ikona,to.workshop,"Obal "+Integer.toString(pocet),isDefault);
       this.to=to;
       pocet++;
   } 

    

    
    @Override
    public void itemReleased(Item i, int x, int y) {
     to.oi.itemReleased(i, this, x, y);
    }

    
    int pressX,pressY;
    int lastX,lastY;
    boolean pressed;
    
    @Override
    public void mouseMoved(int x, int y) {
        if (pressed){
             to.oi.mouseDragged(pressX, pressY,lastX,lastY, x, y, this);
        }
        lastX=x;
        lastY=y;
        this.zmenIkona(to.oi.vykresliMa(this));
    }

    @Override
    public void mousePressed(int x, int y) {
      pressX=x;
      pressY=y;
      pressed=true;
    }

    @Override
    public void mouseReleased(int x, int y) {
       pressed=false;
       this.zmenIkona(to.oi.vykresliMa(this));
    }

    @Override
    public BufferedImage getWorkImage() {
      return to.oi.vykresliMa(this);      
    }

    @Override
    public Object clone() {
     Obal obal=new Obal(this.to,false);
     obal.PusnyPrach1=this.PusnyPrach1;
     obal.PusnyPrach2=this.PusnyPrach2;
     obal.gulicky=(ArrayList)this.gulicky.clone();
     return obal;
    }
    
   public static class GulickaNaVybuchnutie{
       public int x,y;
       public Gulicka g;
       public int angle;
       
       
       final static long Trvanie=500;//Trvanie horenia gulicky
       private long endTime;
       private float xforce,yforce;
       private float gravity;
       private float xInMove,yInMove;
       
       public GulickaNaVybuchnutie(int angle,int x,int y,Gulicka g){
          this.x=x;
          this.y=y;
          this.g=g;
          this.angle=angle;
       }
       
       public static class Point{
           float x,y;
                   
           public Point(float x,float y){
               this.x=x;
               this.y=y;
           }        
       }
       
       ArrayList<Point> body=new ArrayList<>();
       
       public void initializeMove(float x,float y,float gravity,float initialForce){
           xInMove=x;
           yInMove=y;
           this.gravity=gravity;
           xforce=(float)Math.sin(Math.toRadians(angle))*initialForce;
           yforce=(float)Math.cos(Math.toRadians(angle))*initialForce;
           lastTime=System.currentTimeMillis();
           endTime=System.currentTimeMillis()+Trvanie;
       }
       
       private long lastTime;
       boolean active=true;
       
       public void update(int bottom){
           long time=System.currentTimeMillis()-lastTime;
           lastTime=System.currentTimeMillis();
           float downforce=gravity*(time/1000);
           yforce+=downforce;
           yInMove+=yforce;
           xInMove+=xforce;
           body.add(new Point(xInMove,yInMove));
            if (y<bottom){
                y=bottom;
            }
            if (System.currentTimeMillis()>endTime){
                active=false;
            }
       }
          
       public void vykresliSa(Graphics g){
           this.g.vykresliSa(Math.round(xInMove), Math.round(yInMove), g);
           g.setColor(this.g.farba);
           Point lastPoint=null;
           for (Point p:body){
               if (lastPoint==null){
                   lastPoint=p;
               }else{
                   g.drawLine(Math.round(lastPoint.x), Math.round(lastPoint.y), Math.round(p.x), Math.round(p.y));
               }
           }
       }
       
   }
   
   






//Odpal, Dynamika a podobne veci
   final static long maxTime=5000;//v milisekundach
   final static float launchForce=10;
   final static float explosionForce=10;
   
   private float xforce,yforce;
   private float gravity;
   private float x,y;
   private long startTime;
   private long explodeTime;
   private int bottom;
   
   public void odpal(int startx,int starty,int startAngle,int gravity,int bottom){
       this.gravity=gravity;
       this.x=startx;
       this.y=starty;
       this.bottom=bottom;
       startTime=System.currentTimeMillis();     
       explodeTime=startTime+(long)(timer*maxTime);
       float initialForce=PusnyPrach1*launchForce;
       xforce=(float)Math.sin(Math.toRadians(startAngle))*initialForce;
       yforce=(float)Math.cos(Math.toRadians(startAngle))*initialForce;
       lastTime=System.currentTimeMillis();
   }
   
   private long lastTime;
   private boolean exploded;
   
   public void update(){
       if (!exploded){
           if (System.currentTimeMillis()>explodeTime){
                explode();
                exploded=true;
                return;
            }          
           long time=System.currentTimeMillis()-lastTime;
            lastTime=System.currentTimeMillis();
            float downforce=gravity*(time/1000);
            yforce+=downforce;
            y+=yforce;
            x+=xforce;
            if (y>bottom){
                y=bottom;
            }
       }else{
           updateAfterExplosion();
       }
   }
   
   private void explode(){
       for (GulickaNaVybuchnutie gnv:gulicky){
           gnv.initializeMove(x,y,gravity,explosionForce*PusnyPrach2);
       }
   }
   
   private void updateAfterExplosion(){
       ArrayList<GulickaNaVybuchnutie> toRemove=new ArrayList<>();
       for (GulickaNaVybuchnutie gnv:gulicky){
           if (gnv.active){
               gnv.update(pocet);
           }else{
               toRemove.add(gnv);
           }
       }
       for (GulickaNaVybuchnutie gnv:toRemove){
           gulicky.remove(gnv);
       }
   }
   
    public void vykresliSa(Graphics g){
       g.setColor(Color.GRAY);
       g.fillRect(Math.round(x), Math.round(y), 2, 2);
        if (exploded){
           for (GulickaNaVybuchnutie gnv:gulicky){
               if (gnv.active){
                gnv.vykresliSa(g);
               }
           }
       }
    }
       
       
   }
    
   
    
    

