package firework.komponenty;

import firework.Refreshable;
import firework.komponenty.Komponent;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import javax.swing.JPanel;
import firework.itemy.Item;
import java.awt.event.MouseEvent;
import firework.panely.Panel.Mouse;


public class VerticalList extends Komponent{
    
    private int scrolly=0;/*vzdialenost od horneho okraja tohto komponentu 
     napr. ak je scrolly -2 znamena to ze zaciatocny bod je o 2 pixely vyssie ako basey
    */
    private int neededheight;
    private ArrayList<Ikona> ikony;
    final static int vzdialenost=10;//vzdialenost medzi Ikonkami

    
    public VerticalList(int x,int y,int height,int width,Refreshable r,int iconheight,Mouse m,ArrayList<Item> itemy){
        super(x,y,width,height,m,r);
        
        Ikona.height=iconheight;
        Ikona.width=width;
        ikony=new ArrayList<>();
        neededheight=Ikona.height*itemy.size();
        for (Item i:itemy){
            ikony.add(new Ikona(i.ikona,i,i.nazov,super.x,super.y,height));
        }
    }
    
    @Override
    public void vykresliSa(Graphics g) {       
        g.setColor(Color.WHITE);
        g.fillRect(x, y, width, height);
        int actualy=0;//aktualna hodnota Y suradnice
        for (Ikona i:ikony){
            i.vykresliSa(g,super.x,actualy,scrolly);
            actualy+=Ikona.height+vzdialenost;
        }
        //Pekny Ramcek
        g.setColor(Color.BLACK);
        g.drawRect(super.x, super.y, super.width,super.height);
    }
    /**
     * Scrollovanie
     * @param scrolly 
     */
    private void scroll(int scrolly){
        if (neededheight>super.height){
            this.scrolly-=scrolly;
            int maxscroll=-(neededheight-height);
            if (this.scrolly>0){
                this.scrolly=0;
            }
            if (this.scrolly<maxscroll){
                this.scrolly=maxscroll;
            }
        }
    }
    
    public void addItem(Item i){
            ikony.add(new Ikona(i.ikona,i,i.nazov,super.x,super.y,height));
            r.refresh();
    }
    /**
     * Vrati Item ktory je na danych suradniciach
     * @param x X suradnica
     * @param y Y suradnica
     * @return Item ktory je na danych suradniciach,
     * Pozor! ak nieje najdeny ziadny Item vrati sa null
     */
    private Item zistiItem(int x,int y){
        if (super.jeVnutri(x, y)){
            int actualy=super.y+scrolly;
            for (Ikona i:ikony){
                int vyska=Ikona.height;
                if (actualy<y&&y<actualy+vyska){
                    return i.item;
                }
                actualy+=vyska+vzdialenost;
            }
        }
        return null;
    }

    int pressY;//kde bolo stlacene prave tlacidlo
    boolean rightbtnpressed;
    
    @Override
    public void mouseMoved(MouseEvent me) {       
        //Kontrola ci je dany MouseEvent v Komponente
        if (!jeVnutri(me.getX(), me.getY())){
            rightbtnpressed=false;
            return;
        }
        if (rightbtnpressed){
            scroll(pressY-me.getY());
            pressY=me.getY();
        }
        r.refresh();
    }

    @Override
    public void mousePressed(MouseEvent me) {
        //Kontrola ci je dany MouseEvent v Komponente
        if (!jeVnutri(me.getX(), me.getY())){
            return;
        }
        //Stlacenie Praveho Tlacidla
        if (me.getButton()==MouseEvent.BUTTON3){
            rightbtnpressed=true;
            pressY=me.getY();
        }else 
            //Stlacenie Laveho Tlacidla
            if (me.getButton()==MouseEvent.BUTTON1){
                m.item=zistiItem(me.getX(),me.getY());
            }
        r.refresh();
    }

    @Override
    public void mouseReleased(MouseEvent me) {
         //Kontrola ci je dany MouseEvent v Komponente
        if (!jeVnutri(me.getX(), me.getY())){
            return;
        }
        rightbtnpressed=false;
        r.refresh();
    }

    
    private static class Ikona{
        static int width,height;
        private int listheight;
        final static int okraj=12;//vzdialenost od oboch okrajov (aj text aj obrazok)
        BufferedImage ikona;
        Item item;//item ktory tato ikona reprezentuje
        final static Font font=new Font(Font.DIALOG,Font.BOLD,12);//TODO size of font
        private int basex,basey;//Pozicia celeho VerticalListu
        
        public Ikona(BufferedImage ikona,Item item,String popis,int basex,int basey,int listheight){
            this.ikona=new BufferedImage(Ikona.width,Ikona.height,BufferedImage.TYPE_4BYTE_ABGR);
            //Tvorba ikony (obrazku)
            Graphics g=this.ikona.getGraphics();
            g.setFont(font);
            FontMetrics fm=g.getFontMetrics();
            int fontheight=fm.getHeight();
            g.drawImage(ikona,okraj,0,Ikona.width-(okraj*2),Ikona.height-fontheight,null);
            g.setColor(Color.BLACK);
            g.drawString(popis,okraj,Ikona.height);
            this.basex=basex;
            this.basey=basey;
            this.listheight=listheight;
            this.item=item;
        }
        
        public void vykresliSa(Graphics g,int xpos,int ypos,int scrolly){
            BufferedImage obrazok=ikona;
            int y=ypos+scrolly+basey;
            //orezavanie obrazku
            if (y<basey){
                int difference=basey-y;
                int newheight=Ikona.height-difference;
                y=difference;
                if (y>Ikona.height||newheight<=0||y<0){
                    obrazok=null;
                }else{
                    obrazok=ikona.getSubimage(0,y,Ikona.width,newheight);
                }
                y=basey;
            }else if (y+Ikona.height>basey+listheight){
                int height=(basey+listheight)-y;
                if (height<=0){
                    obrazok=null;
                }else{
                obrazok=ikona.getSubimage(0,0,Ikona.width,height);
                }
            }            
            g.drawImage(obrazok, xpos, y, null);
        }
    }
}
