package firework.komponenty;

import firework.Refreshable;
import firework.itemy.Item;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import firework.panely.Panel.Mouse;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.image.BufferedImage;

public class WorkShop extends Komponent {
    
    
    private Item item;
    
    final static int maxwidth=500;
    final static int maxheight=500;
    
    int itemx,itemy,itemwidth,itemheight;
    
    public WorkShop(int x,int y,int width,int height,Mouse m,Refreshable r){
        super(x,y,width,height,m,r);
        System.out.println(this.width);
    }

    @Override
    public void vykresliSa(Graphics g) {
        if (item!=null){
        BufferedImage image=item.getWorkImage();
        itemwidth=image.getWidth();
        itemheight=image.getHeight();
        if (itemwidth>maxwidth){
            itemwidth=maxwidth;
        }
        if (itemheight>maxheight){
            itemheight=maxheight;
        }
        
        itemx=this.x+(this.width-itemwidth)/2;
        itemy=this.y+(this.height-itemheight)/2;       
        g.drawImage(image, itemx,itemy,itemwidth,itemheight, null);
        }else{
            //Ak je item null zobrazi sa pomocna sprava
            String msg="Potiahni sem Item";
            FontMetrics fm=g.getFontMetrics();
            int x=this.x+(super.width-fm.charsWidth(msg.toCharArray(), 0, msg.length()))/2;
            int y=this.y+(this.height-fm.getHeight())/2;
            g.setColor(Color.BLACK);
            g.drawString(msg, x,y);
        }
    }    
    

    public Item saveItem(){
        Item item=this.item;
        discardItem();
        return item;       
    }
    
    public void discardItem(){
        item=null;
    }
    
    
    private void setItem(Item i){
        
        this.item=(Item)i.clone(); 
        
    }

    //TODO IMPLEMENT METHODS
    @Override
    public void mouseMoved(MouseEvent me) {
        int xItem=me.getX()-itemx;//x v Iteme
        int yItem=me.getY()-itemy;//y v Iteme
        if (item!=null){
             item.mouseMoved(xItem, yItem);
        }
    }

    @Override
    public void mousePressed(MouseEvent me) {
        int xItem=me.getX()-itemx;//x v Iteme
        int yItem=me.getY()-itemy;//y v Iteme
        if (item!=null){
             item.mousePressed(xItem, yItem);
        }
    }

    @Override
    public void mouseReleased(MouseEvent me) {
        int xItem=me.getX()-itemx;//x v Iteme
        int yItem=me.getY()-itemy;//y v Iteme
        Item released=m.item;
        if (released!=null){
            if (item==null){
                    setItem(released);                   
                          
            }else if (jeVIteme(me.getX(),me.getY())){
                
                    item.itemReleased((Item)released.clone(),xItem,yItem);
            }
        }else if (item!=null){
            item.mouseReleased(xItem, yItem);
        }
    }
    /**
     * Kontroluje ci je dany bod v Iteme
     */
    private boolean jeVIteme(int x,int y){
        boolean horizontal=itemx<x&&x<itemx+itemwidth;
        boolean vertical=itemy<y&&y<itemy+itemheight;
        return vertical&&horizontal;
    }
}
