package firework.panely;

import firework.FireworkFrame;
import firework.komponenty.*;
import firework.typy.*;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import firework.itemy.*;
import java.awt.Color;
/**
 * Panel na tvorbu guliciek
 */
public class MenuPanel extends Panel {
    
    final static int BTN_LISTA_PRVOK=0;
    final static int BTN_LISTA_GULICKA=1;
    final static int BTN_LISTA_OBAL=2;
    final static int BTN_LISTA_BOX=3;
    
    final static int BTN_LISTB_PRVOK=4;
    final static int BTN_LISTB_GULICKA=5;
    final static int BTN_LISTB_OBAL=6;
    final static int BTN_LISTB_BOX=7;
    
    final static int BTN_DEL=8;
    final static int BTN_SAVE=9;
    final static int BTN_DIS=10;
    final static int BTN_SWITCH=11;
    
    final static int listBx=(Panel.width)-Panel.iconwidth;
    
    
    final static int space=(Panel.width-Panel.iconwidth*2)/4;
    final static int normalBtnWidth=100;
    final static int spaceX=(space-normalBtnWidth)/2; 
    final static int normalBtnHeight=50;
    final static int normalBtnY=Panel.height-100;
    
    private VerticalList gulickaList;
    private VerticalList prvokList;
    private VerticalList obalList;
    private VerticalList boxList;
    private WorkShop ws;
    
    private VerticalList listA;
    private VerticalList listB;
    
    ArrayList<Button> tlacitka=new ArrayList<>();
    
    
    
    
    ArrayList<Prvok> prvky=new ArrayList<>();
    ArrayList<Gulicka> gulicky=new ArrayList<>();
    ArrayList<Obal> obaly=new ArrayList<>();
    ArrayList<Box> boxy=new ArrayList<>();
    FireworkFrame ff;
    
    public MenuPanel(FireworkFrame ff){
        super();
        this.ff=ff;
        for (TypPrvok tp:TypPrvok.values()){
                prvky.add(new Prvok(tp,true));
        }
        for (TypGulicka tg:TypGulicka.values()){
            gulicky.add(new Gulicka(tg,true));
        }
        for (TypObal to:TypObal.values()){
            obaly.add(new Obal(to,true));
        }
        for (TypBox tb:TypBox.values()){
            boxy.add(new Box(tb,true));
        }
        prvokList=new VerticalList(0, Panel.btnheight, Panel.height, Panel.iconwidth,this,Panel.iconheight,this.mouse,(ArrayList)prvky);
        gulickaList=new VerticalList(listBx, Panel.btnheight, Panel.height, Panel.iconwidth,this,Panel.iconheight,this.mouse,(ArrayList)gulicky);
        obalList=new VerticalList(0, Panel.btnheight, Panel.height, Panel.iconwidth,this,Panel.iconheight,this.mouse,(ArrayList)obaly);
        boxList=new VerticalList(0,Panel.btnheight, Panel.height, Panel.iconwidth,this,Panel.iconheight,this.mouse,(ArrayList)boxy);
        
        listA=prvokList;
        listB=gulickaList;    
        ws=new WorkShop(Panel.iconwidth, 0, Panel.width-(2*Panel.iconwidth), Panel.height, this.mouse, this);
        int btnwidth=Panel.iconwidth/4;
        for (int i=0;i<4;i++){
            tlacitka.add(new Button(i*btnwidth,0,btnwidth,Panel.btnheight,this.mouse,this,this,i,Integer.toString(i)));
        }
        
        for (int i=4;i<8;i++){
            tlacitka.add(new Button(((Panel.width)-btnwidth*4)+(i-4)*btnwidth,0,btnwidth,Panel.btnheight,this.mouse,this,this,i,Integer.toString(i)));
        }
        int actualx=Panel.iconwidth+spaceX;
        tlacitka.add(new Button(actualx,normalBtnY,normalBtnWidth,normalBtnHeight,this.mouse,this,this,BTN_SAVE,"Save"));
        actualx+=space;
        tlacitka.add(new Button(actualx,normalBtnY,normalBtnWidth,normalBtnHeight,this.mouse,this,this,BTN_SWITCH,"Switch"));
        actualx+=space;
        tlacitka.add(new Button(actualx,normalBtnY,normalBtnWidth,normalBtnHeight,this.mouse,this,this,BTN_DIS,"Discard"));
        actualx+=space;
        tlacitka.add(new Button(actualx,normalBtnY,normalBtnWidth,normalBtnHeight,this.mouse,this,this,BTN_DEL,"Delete"));
        
        
    }
    
    
    
 
    static int pocet=0;
    @Override
    public void paintComponent(Graphics g){
        super.paintComponent(g);
               
        listA.vykresliSa(g);
        listB.vykresliSa(g);
        ws.vykresliSa(g);
        for (Button b:tlacitka){
            b.vykresliSa(g);
        }
        mouse.vykresliSa(g, mousex, mousey);
        if (pressed){
            g.setColor(Color.RED);
            g.fillRect(400, 0, 50, 50);
        }
        pocet++; 
        g.drawString(Integer.toString(pocet), 450, 20);
    }

    @Override
    public void mouseMoved(MouseEvent e) {
     listA.mouseMoved(e);
     listB.mouseMoved(e);
     ws.mouseMoved(e);
     mousex=e.getX();
     mousey=e.getY();
     refresh();
    }

    private boolean pressed;
    
    @Override
    public void mousePressed(MouseEvent e) {
        if (!pressed){
            //Press
            if (listA.jeVnutri(e.getX(), e.getY())){
                listA.mousePressed(e);
            }
            if (listB.jeVnutri(e.getX(), e.getY())){
                listB.mousePressed(e);
            }
            if (ws.jeVnutri(e.getX(), e.getY())){
                ws.mousePressed(e);
            }
            pressed=true;
        }else if (pressed){
            //Release
            if (listA.jeVnutri(e.getX(), e.getY())){
            listA.mouseReleased(e);
            }
            if (listB.jeVnutri(e.getX(),e.getY())){
                listB.mouseReleased(e);
            }
            ws.mouseReleased(e);
            mouse.item=null;
            pressed=false;
        }
        for (Button b:tlacitka){
            if (b.jeVnutri(e.getX(), e.getY())){
                b.mousePressed(e);
            }
        }
        refresh();
    }
    
    private void addItem(Item i){       
        if (i instanceof Gulicka){
           gulickaList.addItem(i);
           gulicky.add((Gulicka)i);
        }else if(i instanceof Obal){
            obalList.addItem(i);
            obaly.add((Obal)i);
        }else if (i instanceof Box){
            boxList.addItem(i);
            boxy.add((Box)i);
        }
        
    }
    
    @Override
    public void mouseReleased(MouseEvent e) {
         for (Button b:tlacitka){
            if (b.jeVnutri(e.getX(), e.getY())){
                b.mouseReleased(e);
            }
        }
      refresh();
    }

    @Override
    public void refresh() {
        repaint();
    }

    @Override
    public void buttonInput(int btnnumber) {
       switch (btnnumber){
           case BTN_LISTA_PRVOK:
               changeListA(prvokList);
               break;
               
           case BTN_LISTA_GULICKA:
               changeListA(gulickaList);
               break;
               
          case BTN_LISTA_OBAL:
               changeListA(obalList);
               break;
           
          case BTN_LISTA_BOX:
               changeListA(boxList);
               break;
              
          case BTN_LISTB_PRVOK:
               changeListB(prvokList);
               break;
               
           case BTN_LISTB_GULICKA:
               changeListB(gulickaList);
               break;
               
          case BTN_LISTB_OBAL:
               changeListB(obalList);
               break;
           
          case BTN_LISTB_BOX:
               changeListB(boxList);
               break;
         
          case BTN_DIS:
              ws.discardItem();
              break;
              
          case BTN_SAVE:
              addItem(ws.saveItem());
              break;
              
          case BTN_SWITCH:
              ff.switchPanels();
              break;
       }
    }
    
    private void changeListA(VerticalList requested){
        if (listB!=requested){
        requested.x=0;
        requested.y=Panel.btnheight;
        this.listA=requested;
        }
    }
    
    private void changeListB(VerticalList requested){
        if (listA!=requested){
        requested.x=listBx;
        requested.y=Panel.btnheight;
        this.listB=requested;
        }
    }

    
    
}
