package firework.panely;

import firework.FireworkFrame;
import firework.itemy.Box;
import firework.itemy.Obal;
import firework.komponenty.BoxControl;
import firework.komponenty.Button;
import firework.komponenty.VerticalList;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import javax.swing.Timer;


public class ScenePanel extends Panel {

    
    
    
    final static int bottomheight=(BoxControl.Buttonheight+BoxControl.TextFieldHeight)*2;
    int actualControlX
            ,actualControlY=Panel.height-bottomheight;
    
    final static int bottomY=Panel.height-bottomheight;
    
    
    public final static int gravity=-50;
    
    
    ArrayList<Box> boxy=new ArrayList<>();
    ArrayList<BoxControl> boxcontrols=new ArrayList<>();
    MenuPanel mp;
    
    final static int BTN_SWITCH=0;
    final static int BTN_HIDE=1;
    
    
    Button hideBtn,switchBtn;
    VerticalList boxyList;
    
    final static int btnheight=50;
    final static int btnwidth=100;
    
    FireworkFrame ff;
    Mouse mouse;
    
    boolean verticalListActive=true;
    
    public ScenePanel(MenuPanel mp,FireworkFrame ff){
        super();
        this.ff=ff;
        this.mp=mp;
        mouse=new Mouse();
        boxyList=new VerticalList(0,0,bottomY,Panel.iconwidth,this,Panel.iconheight,mouse,(ArrayList)mp.boxy);
        switchBtn=new Button(Panel.width-btnwidth,0,btnwidth,btnheight,mouse,this,this,BTN_SWITCH,"Switch");
        hideBtn=new Button(Panel.iconwidth,0,btnwidth,btnheight,mouse,this,this,BTN_HIDE,"Hide");
        Timer t=new Timer(10,new Action());
        t.start();
    }
    
    public void changed(){
        boxyList=new VerticalList(0,0,bottomY,Panel.iconwidth,this,Panel.iconheight,mouse,(ArrayList)mp.boxy);
    }
    
    
    public void addBox(Box b,int x){
        BoxControl bc=new BoxControl(actualControlX, actualControlY, b, this, this);
        actualControlX+=bc.width; 
        if (actualControlX>Panel.width-bc.width){
        actualControlX=0;
        actualControlY+=BoxControl.Buttonheight+BoxControl.TextFieldHeight;
        bc.x=actualControlX;
        bc.y=actualControlY;
        }
        boxcontrols.add(bc);
        b.y=bottomY;
        b.x=x;
        boxy.add(b);
    }
    

    
    private class Action implements ActionListener{

        @Override
        public void actionPerformed(ActionEvent e) {
           for (Box b:boxy){
               b.update();
           }
           repaint();
        }
        
        
    }
    
    
    
    @Override
    public void buttonInput(int btnnumber) {
      switch (btnnumber){
          case BTN_SWITCH:
              ff.switchPanels();              
              break;
              
          case BTN_HIDE:
              if (verticalListActive){
                  hideBtn.x=0;
              }else{
                  hideBtn.x=Panel.iconwidth;
              }
              verticalListActive=!verticalListActive;
      }
    }

    @Override
    public void mouseMoved(MouseEvent e) {
       if (pressed){           
           mousex=e.getX();          
       }
        boxyList.mouseMoved(e);
        repaint();
    }

    int mouseX;
    boolean pressed;
    
    @Override
    public void mousePressed(MouseEvent e) {
        if (pressed){
            if (verticalListActive){
            boxyList.mouseReleased(e);
            }
            if (mouse.item!=null&&mouse.item instanceof Box){
                addBox((Box)mouse.item.clone(),mousex);
            }
            mouse.item=null;
            pressed=false;
        }else{
            if (verticalListActive){
            boxyList.mousePressed(e);
            }
            
            pressed=true;
        }                      
        for (BoxControl bc:boxcontrols){
            if (bc.jeVnutri(e.getX(), e.getY())){
                bc.mousePressed(e);
            }
        }     
        if (switchBtn.jeVnutri(e.getX(), e.getY())){
            switchBtn.mousePressed(e);
        }
        if (hideBtn.jeVnutri(e.getX(), e.getY())){
            hideBtn.mousePressed(e);  
        }
                 
        repaint();
    }

    @Override
    public void mouseReleased(MouseEvent e) {
         switchBtn.mouseReleased(e);
         hideBtn.mouseReleased(e);
         repaint();
    }

    @Override
    public void refresh() {
    repaint();
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.setColor(Color.BLACK);
        g.fillRect(0, 0, Panel.width, Panel.height-bottomheight);        
        for (BoxControl b:boxcontrols){
            b.vykresliSa(g);
        }
        if (verticalListActive){
        boxyList.vykresliSa(g);
        }
        switchBtn.vykresliSa(g);
        hideBtn.vykresliSa(g);
        for (Box b:boxy){
            b.vykresliSa(g);
        }
        if (mouse.item!=null){
            g.drawImage(mouse.item.ikona,  mousex, bottomY-mouse.item.ikona.getHeight(), null);
        }
        
    }
    
}
